/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "config.h"
#include "interface.h"

#define CONFIG_FILE "config/xastir.cnf"
#define CONFIG_FILE_BAK "config/xastir.bak"
#define CONFIG_FILE_TMP "config/xastir.tmp"

#define MAX_VALUE 300

extern int debug_level;
extern int filethere(char *fn);
extern char user_dir[];

/* values to store */
extern char lang_to_use[];
extern char my_callsign[];
extern char my_lat[];
extern char my_long[];
extern char my_group;
extern char my_symbol;
extern char aprs_station_message_type;
extern char my_phg[];
extern char my_comment[];
extern long screen_width;
extern long screen_height;
extern long mid_y_lat_offset;
extern long mid_x_long_offset;
extern int  position_amb_chars;
extern long size;
extern int  map_background_color;
extern int  letter_style;
extern int  wx_alert_style;
extern char WIN_MAP_DIR[];
extern char ALERT_MAP_DIR[];
extern char WIN_MAP_DIR[];
extern char WIN_MAP_DATA[];
extern char AUTO_MAP_DIR[];
extern char SYMBOLS_DIR[];
extern char SOUND_DIR[];
extern char MDATABASE_FILE[];
extern char MDATABASE_POINTER_FILE[];
extern char MDATABASE_POINTER_TEMP[];
extern int  long_lat_grid;
extern int  map_color_levels;
extern int  map_auto_maps;
extern int  symbol_callsign_display;
extern int  symbol_alt_display;
extern int  symbol_course_display;
extern int  symbol_speed_display;
extern int  symbol_dist_course_display;
extern int  units_english_metric;
extern int  station_trails;
extern int  show_phg;
extern int  symbol_weather_display;
extern time_t gps_time;
extern ioparam devices[];
extern int  transmit_raw_wx;
extern int  transmit_compressed_posit;
extern int  log_tnc_data;
extern char LOGFILE_TNC[];
extern int  log_net_data;
extern int  operate_as_an_igate;
extern int  log_igate;
extern int  log_wx;
extern char LOGFILE_IGATE[];
extern char LOGFILE_NET[];
extern char LOGFILE_WX[];

extern int  output_station_type;
extern char sound_command[];
extern int  sound_play_new_station;
extern char sound_new_station[];
extern int  sound_play_new_message;
extern char sound_new_message[];
extern int  sound_play_prox_message;
extern char sound_prox_message[];
extern char prox_min[];
extern char prox_max[];
extern int  sound_play_band_open_message;
extern char sound_band_open_message[];
extern char bando_min[];
extern char bando_max[];
extern int  sound_play_wx_alert_message;
extern char sound_wx_alert_message[];
extern long sec_old;
extern long sec_clear;
extern char HELP_FILE[];
extern int  message_counter;
extern char auto_reply_message[];
extern int  Display_packet_data_type;

extern int  NETWORK_WAITTIME;
extern int  WX_ALERTS_REFRESH_TIME;

extern int list_size_h[];
extern int list_size_w[]; 

void store_string(FILE *fout, char *option, char *value)
{

 if (debug_level & 1)
    printf("Store String Start\n");
    
 fprintf(fout,"%s:%s\n",option,value);

 if (debug_level & 1)
    printf("Store String Stop\n");

}


void store_char(FILE *fout, char *option, char value)
{char value_o[2];

 value_o[0]=value;
 value_o[1]=0;
 store_string(fout,option,value_o);
}

void store_int(FILE *fout, char *option, int value)
{char value_o[MAX_VALUE];

 sprintf(value_o,"%d",value);
 store_string(fout,option,value_o);
}

void store_long(FILE *fout, char *option, long value)
{char value_o[MAX_VALUE];

 sprintf(value_o,"%ld",value);
 store_string(fout,option,value_o);
}




int get_string(char *option, char *value)
{
FILE *fin;
char option_in[100], value_in[MAX_VALUE];
char cin;
int pos_opt,pos_val,on;
int option_found;
 char config_file[MAX_VALUE];

strcpy(option_in,"");
strcpy(value_in,"");
option_found=0;
 strcpy(config_file, get_user_base_dir(CONFIG_FILE));
fin=fopen(config_file,"r");
if(fin!=NULL)
  {pos_opt=pos_val=0;
   on=0;
   while(!feof(fin) && !option_found)
        {if(fread(&cin,1,1,fin)==1)
           {if(cin!=10 && cin!=13)
              {if(cin!=':')
                 {if(!on)
                    {option_in[pos_opt++]=cin;}
                    else
                    {value_in[pos_val++]=cin;}
		 }
                 else
                 {on++;
                  option_in[pos_opt]=0;         
                 }
	      }
              else
              {value_in[pos_val]=0;
               pos_opt=0;
               pos_val=0;
               on=0;
               /* check data */
               if(strcmp(option_in,option)==0)
                 {option_found=1;
                  strcpy(value,value_in);
                  }                   
	      }
	   }
	}
  }
if(fin!=NULL)
  {fclose(fin);}
return(option_found);
}

int get_char(char *option, char *value)
{char value_o[MAX_VALUE];
 int ret;

 ret = get_string(option,value_o);
 if(ret)
   {*value = value_o[0];} 
return(ret);
}

int get_int(char *option, int *value)
{char value_o[MAX_VALUE];
 int ret;

 ret = get_string(option,value_o);
 if(ret)
   {*value = atoi(value_o);} 
return(ret);
}

int get_long(char *option, long *value)
{char value_o[MAX_VALUE];
 int ret;

 ret = get_string(option,value_o);
 if(ret)
   {*value = atol(value_o);} 
return(ret);
}

char *get_user_base_dir(char *dir)
{
    static char base[MAX_VALUE];
    char *env_ptr;
    strcpy(base, ((env_ptr = getenv("XASTIR_USER_BASE")) != NULL) ? env_ptr: XASTIR_USER_BASE);
    if (base[strlen(base)-1] != '/') 
       {sprintf(base,"%s/.xastir/",user_dir);
        /*sprintf(base,"%s/",XASTIR_BASE);*/
       }
    return strcat(base, dir);
}

char *get_data_base_dir(char *dir)
{
    static char base[MAX_VALUE];
    char *env_ptr;
    strcpy(base, ((env_ptr = getenv("XASTIR_DATA_BASE")) != NULL) ? env_ptr: XASTIR_DATA_BASE);
    if (base[strlen(base)-1] != '/') strcat(base, "/");
    return strcat(base, dir);
}

void save_data(void)
{int i;
 char name_temp[20];
 char name[50];
 FILE *fout;
 char config_file[MAX_VALUE], config_file_bak[MAX_VALUE];

if(debug_level & 1)
  {printf("Store String Start\n");}

 strcpy(config_file, get_user_base_dir(CONFIG_FILE));
 strcpy(config_file_bak, get_user_base_dir(CONFIG_FILE_BAK));
 unlink(config_file_bak);
 rename(config_file, config_file_bak);

    fout=fopen(config_file,"a");
    if (fout!=NULL) {
     
    if (debug_level & 1)
       printf("Save Data Start\n");

       /* language */
       store_string(fout,"LANGUAGE",lang_to_use);

       /* my data */
       store_string(fout,"STATION_CALLSIGN",my_callsign);
       store_string(fout,"STATION_LAT",my_lat);
       store_string(fout,"STATION_LONG",my_long);
       store_char(fout,"STATION_GROUP",my_group); 
       store_char(fout,"STATION_SYMBOL",my_symbol);
       store_char(fout,"STATION_MESSAGE_TYPE",aprs_station_message_type);
       store_string(fout,"STATION_POWER",my_phg);
       store_string(fout,"STATION_COMMENTS",my_comment);
       if (debug_level & 2)
          printf("Save Data 1\n");

       /* default values */
       store_long(fout,"SCREEN_WIDTH",screen_width);
       store_long(fout,"SCREEN_HEIGHT",screen_height);
       store_long(fout,"SCREEN_LAT",mid_y_lat_offset);
       store_long(fout,"SCREEN_LONG",mid_x_long_offset);
       store_int(fout,"STATION_TRANSMIT_AMB",position_amb_chars);
       store_long(fout,"SCREEN_ZOOM",size);
       store_int(fout,"MAP_BGCOLOR",map_background_color);
       store_int(fout,"MAP_LETTERSTYLE",letter_style);
       store_int(fout,"MAP_WX_ALERT_STYLE",wx_alert_style);
       store_string(fout,"AUTO_MAP_DIR",AUTO_MAP_DIR);
       store_string(fout,"ALERT_MAP_DIR",ALERT_MAP_DIR);
       store_string(fout,"WIN_MAP_DIR",WIN_MAP_DIR);
       store_string(fout,"WIN_MAP_DATA",WIN_MAP_DATA);
       store_string(fout,"SYMBOLS_DIR",SYMBOLS_DIR);
       store_string(fout,"SOUND_DIR",SOUND_DIR);
       store_string(fout,"MDATABASE_FILE",MDATABASE_FILE);
       store_string(fout,"MDATABASE_POINTER_FILE",MDATABASE_POINTER_FILE);
       store_string(fout,"MDATABASE_POINTER_TEMP",MDATABASE_POINTER_TEMP);

       /* maps */
       store_int(fout,"MAPS_LONG_LAT_GRID",long_lat_grid);
       store_int(fout,"MAPS_LEVELS",map_color_levels);
       store_int(fout,"MAPS_AUTO_MAPS",map_auto_maps);

       /* display values */
       store_int(fout,"DISPLAY_CALLSIGN",symbol_callsign_display);
       store_int(fout,"DISPLAY_ALTITUDE",symbol_alt_display);
       store_int(fout,"DISPLAY_COURSE",symbol_course_display);
       store_int(fout,"DISPLAY_SPEED",symbol_speed_display);
       store_int(fout,"DISPLAY_DIST_COURSE",symbol_dist_course_display);
       store_int(fout,"DISPLAY_UNITS_ENGLISH",units_english_metric);
       store_int(fout,"DISPLAY_STATION_TRAILS",station_trails);
       store_int(fout,"DISPLAY_STATION_PHG",show_phg);
       store_int(fout,"DISPLAY_STATION_WX",symbol_weather_display);

       for (i=0;i<MAX_IFACE_DEVICES;i++) {
          sprintf(name_temp,"DEVICE%0d_",i);

          strcpy(name,name_temp);
          strcat(name,"TYPE"); 
          store_int(fout,name,devices[i].device_type);

          strcpy(name,name_temp);
          strcat(name,"NAME"); 
          store_string(fout,name,devices[i].device_name);

          strcpy(name,name_temp);
          strcat(name,"HOST"); 
          store_string(fout,name,devices[i].device_host_name);

          strcpy(name,name_temp);
          strcat(name,"PASSWD"); 
          store_string(fout,name,devices[i].device_host_pswd);

          strcpy(name,name_temp);
          strcat(name,"UNPROTO1"); 
          store_string(fout,name,devices[i].unproto1);

          strcpy(name,name_temp);
          strcat(name,"UNPROTO2"); 
          store_string(fout,name,devices[i].unproto2);

          strcpy(name,name_temp);
          strcat(name,"UNPROTO3"); 
          store_string(fout,name,devices[i].unproto3);

          strcpy(name,name_temp);
          strcat(name,"TNC_UP_FILE"); 
          store_string(fout,name,devices[i].tnc_up_file);

          strcpy(name,name_temp);
          strcat(name,"TNC_DOWN_FILE"); 
          store_string(fout,name,devices[i].tnc_down_file);

          strcpy(name,name_temp);
          strcat(name,"SPEED"); 
          store_int(fout,name,devices[i].sp);

          strcpy(name,name_temp);
          strcat(name,"STYLE"); 
          store_int(fout,name,devices[i].style);

          strcpy(name,name_temp);
          strcat(name,"IGATE_OPTION"); 
          store_int(fout,name,devices[i].igate_options);

          strcpy(name,name_temp);
          strcat(name,"TXMT"); 
          store_int(fout,name,devices[i].transmit_data);

          strcpy(name,name_temp);
          strcat(name,"RECONN"); 
          store_int(fout,name,devices[i].reconnect);

          strcpy(name,name_temp);
          strcat(name,"ONSTARTUP"); 
          store_int(fout,name,devices[i].connect_on_startup);
       }

       /* TNC */
       store_int(fout,"TNC_LOG_DATA",log_tnc_data);
       store_string(fout,"LOGFILE_TNC",LOGFILE_TNC);

       /* NET */
       store_int(fout,"NET_LOG_DATA",log_net_data);
       store_int(fout,"NET_RUN_AS_IGATE",operate_as_an_igate);
       store_int(fout,"NETWORK_WAITTIME",NETWORK_WAITTIME); 

       store_int(fout,"LOG_IGATE",log_igate);
       store_int(fout,"LOG_WX",log_wx);
       store_string(fout,"LOGFILE_IGATE",LOGFILE_IGATE);
       store_string(fout,"LOGFILE_NET",LOGFILE_NET);
       store_string(fout,"LOGFILE_WX",LOGFILE_WX);

       /* WX ALERTS */
       store_int(fout,"WX_ALERTS_REFRESH_TIME",WX_ALERTS_REFRESH_TIME); 
 
       /* GPS */
       store_long(fout,"GPS_TIME",gps_time); /* still needed */

       /* station broadcast type */
       store_int(fout,"BST_TYPE",output_station_type);
       store_int(fout,"BST_WX_RAW",transmit_raw_wx);
       store_int(fout,"BST_COMPRESSED_POSIT",transmit_compressed_posit);

       /* Audio Alarms*/
       store_string(fout,"SOUND_COMMAND",sound_command);
       store_int(fout,"SOUND_PLAY_ONS",sound_play_new_station);
       store_string(fout,"SOUND_ONS_FILE",sound_new_station);
       store_int(fout,"SOUND_PLAY_ONM",sound_play_new_message);
       store_string(fout,"SOUND_ONM_FILE",sound_new_message);

       store_int(fout,"SOUND_PLAY_PROX",sound_play_prox_message);
       store_string(fout,"SOUND_PROX_FILE",sound_prox_message);
       store_string(fout,"PROX_MIN",prox_min);
       store_string(fout,"PROX_MAX",prox_max);
       store_int(fout,"SOUND_PLAY_BAND",sound_play_band_open_message);
       store_string(fout,"SOUND_BAND_FILE",sound_band_open_message);
       store_string(fout,"BANDO_MIN",bando_min);
       store_string(fout,"BANDO_MAX",bando_max);
       store_int(fout,"SOUND_PLAY_WX_ALERT",sound_play_wx_alert_message);
       store_string(fout,"SOUND_WX_ALERT_FILE",sound_wx_alert_message); 

       /* defaults */
       store_long(fout,"DEFAULT_STATION_OLD",sec_old);
       store_long(fout,"DEFAULT_STATION_CLEAR",sec_clear);
       store_string(fout,"HELP_DATA",HELP_FILE);
       store_int(fout,"MESSAGE_COUNTER",message_counter);
       store_string(fout,"AUTO_MSG_REPLY",auto_reply_message);
       store_int(fout,"DISPLAY_PACKET_TYPE",Display_packet_data_type);

       /* list attributes */
       for (i=0;i<4;i++) {
          sprintf(name_temp,"LIST%0d_",i);

          strcpy(name,name_temp);
          strcat(name,"H"); 
          store_int(fout,name,list_size_h[i]);

          strcpy(name,name_temp);
          strcat(name,"W"); 
          store_int(fout,name,list_size_w[i]);
       } 

       if (debug_level & 1)
          printf("Save Data Stop\n");
    fclose(fout);  
    }

}


void load_data_or_default(void)
{int i;
 char name_temp[20];
 char name[50];

/* language */
if(!get_string("LANGUAGE",lang_to_use))
  {strcpy(lang_to_use,"English");}

/* my data */
if(!get_string("STATION_CALLSIGN",my_callsign))
  {strcpy(my_callsign,"NOCALL");}

if(!get_string("STATION_LAT",my_lat))
  {strcpy(my_lat,"0000.00N");}

if(!get_string("STATION_LONG",my_long))
  {strcpy(my_long,"00000.00W");}

if(!get_int("STATION_TRANSMIT_AMB",&position_amb_chars))
  {position_amb_chars=0;}

if(!get_char("STATION_GROUP",&my_group))
  {my_group='/';}

if(!get_char("STATION_SYMBOL",&my_symbol))
  {my_symbol='x';}

if(!get_char("STATION_MESSAGE_TYPE",&aprs_station_message_type))
  {aprs_station_message_type='=';}

if(!get_string("STATION_POWER",my_phg))
  {strcpy(my_phg,"");}

if(!get_string("STATION_COMMENTS",my_comment))
  {
#ifndef SYSTEM
#define SYSTEM "Linux"
#endif
	sprintf(my_comment,"XASTIR-%s", SYSTEM);
  }


/* default values */
if(!get_long("SCREEN_WIDTH",&screen_width))
  {screen_width=640;}

if(screen_width<640)
  {screen_width=640;}

if(!get_long("SCREEN_HEIGHT",&screen_height))
  {screen_height=320;}

if(screen_height<320)
  {screen_height=320;}

if(!get_long("SCREEN_LAT",&mid_y_lat_offset))
  {mid_y_lat_offset=32400000l;}

if(!get_long("SCREEN_LONG",&mid_x_long_offset))
  {mid_x_long_offset=64800000l;}

if(!get_long("SCREEN_ZOOM",&size))
  {size=327680;}

if(!get_int("MAP_BGCOLOR",&map_background_color))
  {map_background_color=0;}

if(!get_int("MAP_LETTERSTYLE",&letter_style))
  {letter_style=1;}

if(!get_int("MAP_WX_ALERT_STYLE",&wx_alert_style))
  {wx_alert_style=1;}

if(!get_string("AUTO_MAP_DIR",AUTO_MAP_DIR))
 {strcpy(AUTO_MAP_DIR,get_data_base_dir("maps"));}

if(!get_string("ALERT_MAP_DIR",ALERT_MAP_DIR))
 {strcpy(ALERT_MAP_DIR,get_data_base_dir("Counties"));}

if(!get_string("WIN_MAP_DIR",WIN_MAP_DIR))
 {strcpy(WIN_MAP_DIR,get_data_base_dir("maps"));}

if(!get_string("WIN_MAP_DATA",WIN_MAP_DATA))
 {strcpy(WIN_MAP_DATA,get_user_base_dir("config/winmaps.sys"));}

if(!get_string("SYMBOLS_DIR",SYMBOLS_DIR))
  {strcpy(SYMBOLS_DIR,get_data_base_dir("symbols"));}

if(!get_string("SOUND_DIR",SOUND_DIR))
  {strcpy(SOUND_DIR,get_data_base_dir("sounds"));}

if(!get_string("MDATABASE_FILE",MDATABASE_FILE))
  {strcpy(MDATABASE_FILE,get_user_base_dir("data/message_db.dat"));}

if(!get_string("MDATABASE_POINTER_FILE",MDATABASE_POINTER_FILE))
  {strcpy(MDATABASE_POINTER_FILE,get_user_base_dir("data/message_db.ptr"));}

if(!get_string("MDATABASE_POINTER_TEMP",MDATABASE_POINTER_TEMP))
  {strcpy(MDATABASE_POINTER_TEMP,get_user_base_dir("data/message_db.tpptr"));}

/* maps */
if(!get_int("MAPS_LONG_LAT_GRID",&long_lat_grid))
  {long_lat_grid=1;}

if(!get_int("MAPS_LEVELS",&map_color_levels))
  {map_color_levels=0;}

if(!get_int("MAPS_AUTO_MAPS",&map_auto_maps))
  {map_auto_maps=0;}

/* display values */
if(!get_int("DISPLAY_CALLSIGN",&symbol_callsign_display))
  {symbol_callsign_display=1;}

if(!get_int("DISPLAY_ALTITUDE",&symbol_alt_display))
  {symbol_alt_display=0;}

if(!get_int("DISPLAY_COURSE",&symbol_course_display))
  {symbol_course_display=0;}

if(!get_int("DISPLAY_SPEED",&symbol_speed_display))
  {symbol_speed_display=0;}

if(!get_int("DISPLAY_DIST_COURSE",&symbol_dist_course_display))
  {symbol_dist_course_display=0;}

if(!get_int("DISPLAY_UNITS_ENGLISH",&units_english_metric))
  {units_english_metric=0;}

if(!get_int("DISPLAY_STATION_TRAILS",&station_trails))
  {station_trails=0;}

if(!get_int("DISPLAY_STATION_PHG",&show_phg))
  {show_phg=0;}

if(!get_int("DISPLAY_STATION_WX",&symbol_weather_display))
  {symbol_weather_display=0;}

for(i=0;i<MAX_IFACE_DEVICES;i++)
   {sprintf(name_temp,"DEVICE%0d_",i);

    strcpy(name,name_temp);
    strcat(name,"TYPE"); 
    if(!get_int(name,&devices[i].device_type))
      {devices[i].device_type=DEVICE_NONE;}

    strcpy(name,name_temp);
    strcat(name,"NAME"); 
    if(!get_string(name,devices[i].device_name))
      {strcpy(devices[i].device_name,"");}


    strcpy(name,name_temp);
    strcat(name,"HOST"); 
    if(!get_string(name,devices[i].device_host_name))
      {strcpy(devices[i].device_host_name,"");}


    strcpy(name,name_temp);
    strcat(name,"PASSWD"); 
    if(!get_string(name,devices[i].device_host_pswd))
      {strcpy(devices[i].device_host_pswd,"");}

    strcpy(name,name_temp);
    strcat(name,"UNPROTO1"); 
    if(!get_string(name,devices[i].unproto1))
      {strcpy(devices[i].unproto1,"");}

    strcpy(name,name_temp);
    strcat(name,"UNPROTO2"); 
    if(!get_string(name,devices[i].unproto2))
      {strcpy(devices[i].unproto2,"");}

    strcpy(name,name_temp);
    strcat(name,"UNPROTO3"); 
    if(!get_string(name,devices[i].unproto3))
      {strcpy(devices[i].unproto3,"");}


    strcpy(name,name_temp);
    strcat(name,"TNC_UP_FILE"); 
    if(!get_string(name,devices[i].tnc_up_file))
      {strcpy(devices[i].tnc_up_file,"");}

    strcpy(name,name_temp);
    strcat(name,"TNC_DOWN_FILE"); 
    if(!get_string(name,devices[i].tnc_down_file))
      {strcpy(devices[i].tnc_down_file,"");}


    strcpy(name,name_temp);
    strcat(name,"SPEED"); 
    if(!get_int(name,&devices[i].sp))
      {devices[i].sp=0;}

    strcpy(name,name_temp);
    strcat(name,"STYLE");
    if(!get_int(name,&devices[i].style))
      {devices[i].style=0;}

    strcpy(name,name_temp);
    strcat(name,"IGATE_OPTION");
    if(!get_int(name,&devices[i].igate_options))
      {devices[i].igate_options=0;} 

    strcpy(name,name_temp);
    strcat(name,"TXMT"); 
    if(!get_int(name,&devices[i].transmit_data))
      {devices[i].transmit_data=0;}

    strcpy(name,name_temp);
    strcat(name,"RECONN");
    if(!get_int(name,&devices[i].reconnect))
      {devices[i].reconnect=0;} 

    strcpy(name,name_temp);
    strcat(name,"ONSTARTUP"); 
    if(!get_int(name,&devices[i].connect_on_startup))
      {devices[i].connect_on_startup=0;}
   }

/* TNC */

if(!get_int("TNC_LOG_DATA",&log_tnc_data))
  {log_tnc_data=0;}

if(!get_string("LOGFILE_TNC",LOGFILE_TNC))
  {strcpy(LOGFILE_TNC,get_user_base_dir("logs/tnc.log"));}



/* NET */
if(!get_int("NET_LOG_DATA",&log_net_data))
  {log_net_data=0;}

if(!get_int("NET_RUN_AS_IGATE",&operate_as_an_igate))
  {operate_as_an_igate=0;}

if(!get_int("LOG_IGATE",&log_igate))
  {log_igate=0;}

if(!get_int("NETWORK_WAITTIME",&NETWORK_WAITTIME))
  {NETWORK_WAITTIME=10;}

if(!get_int("LOG_WX",&log_wx))
  {log_wx=0;}

if(!get_string("LOGFILE_IGATE",LOGFILE_IGATE))
  {strcpy(LOGFILE_IGATE,get_user_base_dir("logs/igate.log"));}


if(!get_string("LOGFILE_NET",LOGFILE_NET))
  {strcpy(LOGFILE_NET,get_user_base_dir("logs/net.log"));}

if(!get_string("LOGFILE_WX",LOGFILE_WX))
  {strcpy(LOGFILE_WX,get_user_base_dir("logs/wx.log"));}

/* WX ALERTS */
if(!get_int("WX_ALERTS_REFRESH_TIME",&WX_ALERTS_REFRESH_TIME))
  {WX_ALERTS_REFRESH_TIME=30;}

/* gps */
if(!get_long("GPS_TIME",&gps_time))
  {gps_time=60l;}


/* station broadcast type */
if(!get_int("BST_TYPE",&output_station_type))
  {output_station_type=0;}

/* raw wx transmit */
if(!get_int("BST_WX_RAW",&transmit_raw_wx))
  {transmit_raw_wx=0;}

/* compressed posit transmit */
if(!get_int("BST_COMPRESSED_POSIT",&transmit_compressed_posit))
  { transmit_compressed_posit=0;}

/* Audio Alarms*/
if(!get_string("SOUND_COMMAND",sound_command))
  {strcpy(sound_command,"vplay -q");}

if(!get_int("SOUND_PLAY_ONS",&sound_play_new_station))
  {sound_play_new_station=0;}

if(!get_string("SOUND_ONS_FILE",sound_new_station))
  {strcpy(sound_new_station,"newstation.wav");}

if(!get_int("SOUND_PLAY_ONM",&sound_play_new_message))
  {sound_play_new_message=0;}

if(!get_string("SOUND_ONM_FILE",sound_new_message))
  {strcpy(sound_new_message,"newmessage.wav");}


if(!get_int("SOUND_PLAY_PROX",&sound_play_prox_message))
   {sound_play_prox_message=0;}

if(!get_string("SOUND_PROX_FILE",sound_prox_message))
   {strcpy(sound_prox_message,"proxwarn.wav");}

if(!get_string("PROX_MIN",prox_min))
   {strcpy(prox_min,"0.01");}

if(!get_string("PROX_MAX",prox_max))
   {strcpy(prox_max,"10");}

if(!get_int("SOUND_PLAY_BAND",&sound_play_band_open_message))
   {sound_play_band_open_message=0;}

if(!get_string("SOUND_BAND_FILE",sound_band_open_message))
  {strcpy(sound_band_open_message,"bandopen.wav");}

if(!get_string("BANDO_MIN",bando_min))
  {strcpy(bando_min,"200");}

if(!get_string("BANDO_MAX",bando_max))
  {strcpy(bando_max,"2000");}

if(!get_int("SOUND_PLAY_WX_ALERT",&sound_play_wx_alert_message))
  sound_play_wx_alert_message=0;

if(!get_string("SOUND_WX_ALERT_FILE",sound_wx_alert_message))
  strcpy(sound_wx_alert_message,"thunder.wav");
 

/* defaults */
if(!get_long("DEFAULT_STATION_OLD",&sec_old))
  {sec_old=7200l;}

if(!get_long("DEFAULT_STATION_CLEAR",&sec_clear))
  {sec_clear=43200l;}

if(!get_int("MESSAGE_COUNTER",&message_counter))
  {message_counter=0;}

if(!get_string("AUTO_MSG_REPLY",auto_reply_message))
  {strcpy(auto_reply_message,"Autoreply- No one is at the keyboard");}

if(!get_int("DISPLAY_PACKET_TYPE",&Display_packet_data_type))
  {Display_packet_data_type = 0;}

/* list attributes */
for (i=0;i<4;i++) 
   {sprintf(name_temp,"LIST%0d_",i);

    strcpy(name,name_temp);
    strcat(name,"H"); 
    if(!get_int(name,&list_size_h[i]))
      {list_size_h[i]=-1;}

    strcpy(name,name_temp);
    strcat(name,"W"); 
    if(!get_int(name,&list_size_w[i]))
      {list_size_w[i]=-1;}
   }
}

