/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <dirent.h>
#include <netinet/in.h>

#include <Xm/TextF.h>

#include "xastir.h"

/* from main.c */
extern void create_image(Widget w);
extern int track_station_on;
extern Widget text4;

long last_mid_x_long_offset;
long last_mid_y_lat_offset;
long last_size;


/***********************************************************/
/* set zoom text                                           */
/***********************************************************/
void zoom_text(void)
{char zoom[30];

 if (track_station_on!=1) { 
    sprintf(zoom,langcode("BBARZM0001"),size);
 } else {
   sprintf(zoom,langcode("BBARZM0002"),size);
 }

 XmTextFieldSetString(text4,zoom);

}

/***********************************************************/
/* set last map position                                   */
/* store lat long and zoom                                 */
/***********************************************************/
void set_last_position(void)
{
 last_mid_x_long_offset=mid_x_long_offset;
 last_mid_y_lat_offset=mid_y_lat_offset;
 last_size=size;
}

/***********************************************************/
/* reset map to last position                              */
/*                                                         */
/***********************************************************/
void map_pos_last_position(void)
{long mid_x, mid_y, sz;

 mid_x = last_mid_x_long_offset;
 mid_y = last_mid_y_lat_offset;
 sz = last_size;

 set_last_position();

 mid_x_long_offset = mid_x;
 mid_y_lat_offset = mid_y;
 size =sz;

 zoom_text();

 create_image(da);
 XCopyArea(XtDisplay(da),pixmap_final,XtWindow(da),gc,0,0,screen_width,screen_height,0,0);
}



/***********************************************************/
/* Jump map to position                                    */
/*                                                         */
/***********************************************************/
void map_pos(long mid_y, long mid_x, long sz)
{
 set_last_position();

 mid_x_long_offset = mid_x;
 mid_y_lat_offset = mid_y;
 size =sz;

 zoom_text();

 create_image(da);
 XCopyArea(XtDisplay(da),pixmap_final,XtWindow(da),gc,0,0,screen_width,screen_height,0,0);

}


