/*
XASTIR, Amateur Station Tracking and Information Reporting
Copyright (C) 1999  Frank Giannandrea

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

More information on the program can be found at:
Web,
 http://www.eazy.net/users/fgiannan/xasitr/
Email,
 fgiannan@eazy.net
*/

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/PanedW.h>
#include <Xm/Protocols.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>


#include "main.h"
#include "xastir.h"


extern Widget appshell;
extern Widget GetTopShell(Widget w);
extern void pos_dialog(Widget w);
extern Widget text4;

/* from lang.c */
extern char *langcode(char *code);
extern char langcode_hotkey(char *code);

/* from popup_gui.c */
extern void popup_message(char *banner, char *message);

Widget track_station_dialog = (Widget)NULL;
Widget track_station_data = (Widget)NULL;

/* track values */
Widget track_case_data, track_match_data;

int track_station_on;           /* used for tracking stations */
int track_case;                 /* used for tracking stations */
int track_match;                /* used for tracking stations */
char tracking_station_call[30]; /* Tracking station callsign */


/**** Track STATION ******/

void track_station_destroy_shell(Widget widget, XtPointer clientData, XtPointer callData)
{ 
 Widget shell = (Widget) clientData;
 XtPopdown(shell);
 XtDestroyWidget(shell);
 track_station_dialog = (Widget)NULL;
}

void Track_station_clear(Widget w, XtPointer clientData, XtPointer callData)
{char zoom[30];
/* clear station */
track_station_on=0;
track_station_data=NULL;
strcpy(tracking_station_call,"");

if(track_station_on!=1)
  {sprintf(zoom,langcode("BBARZM0001"),size);}
   else
  {sprintf(zoom,langcode("BBARZM0002"),size);}
XmTextFieldSetString(text4,zoom);
track_station_destroy_shell(w, clientData, callData);
}

void Track_station_now(Widget w, XtPointer clientData, XtPointer callData)
{char temp[MAX_CALL+1];
 char zoom[30];
 char temp2[200];

 /* find station and go there */
 strcpy(temp,XmTextFieldGetString(track_station_data));
 remove_trailing_spaces(temp);
 strcpy(tracking_station_call,temp);
 track_case = XmToggleButtonGetState(track_case_data);
 track_match = XmToggleButtonGetState(track_match_data);
 track_station_on=locate_station(da, temp,track_case,track_match);
 if(track_station_on!=1)
   {sprintf(zoom,langcode("BBARZM0001"),size);
    sprintf(temp2,langcode("POPEM00002"),temp);
    popup_message(langcode("POPEM00003"),temp2); 
   }
   else
   {sprintf(zoom,langcode("BBARZM0002"),size);}
 XmTextFieldSetString(text4,zoom);
 track_station_destroy_shell(w, clientData, callData);
}

void Track_station(Widget w, XtPointer clientData, XtPointer callData)
{static Widget pane, form, button_ok, button_cancel, button_clear, call, sep;
 Atom delw;


 if(!track_station_dialog)   
   {track_station_dialog = XtVaCreatePopupShell(langcode("WPUPTSP001"),xmDialogShellWidgetClass,hidden_shell,
                                  XmNdeleteResponse,XmDESTROY,
                                  XmNdefaultPosition, False,
                                  NULL);

    pane = XtVaCreateWidget("pane",xmPanedWindowWidgetClass, track_station_dialog,
                          XmNbackground, colors[0xff],
                          NULL);           

    form =  XtVaCreateWidget("form2",xmFormWidgetClass, pane,
                            XmNfractionBase, 3, 
                            XmNbackground, colors[0xff],
                            XmNautoUnmanage, False,
                            XmNshadowThickness, 1,
                            NULL);

    call = XtVaCreateManagedWidget(langcode("WPUPTSP002"),xmLabelWidgetClass, form,
                                      XmNtopAttachment, XmATTACH_FORM,
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      NULL);


    track_station_data = XtVaCreateManagedWidget("track locate data", xmTextFieldWidgetClass, form,
                                      XmNeditable,   True,
                                      XmNcursorPositionVisible, True,
                                      XmNsensitive, True,
				      XmNshadowThickness,	1,
                                      XmNcolumns, 15,
                                      XmNwidth, ((15*7)+2),
                                      XmNmaxLength, 15,
                                      XmNbackground, colors[0x0f],
                                      XmNtopAttachment,XmATTACH_FORM,
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget, call,
                                      XmNleftOffset, 10,
                                      XmNrightAttachment,XmATTACH_NONE,
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);


    track_case_data  = XtVaCreateManagedWidget(langcode("WPUPTSP003"),xmToggleButtonWidgetClass,form,                                     
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, call,
                                      XmNtopOffset, 20, 
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNleftOffset ,10,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);  

    track_match_data  = XtVaCreateManagedWidget(langcode("WPUPTSP004"),xmToggleButtonWidgetClass,form,                                     
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, call,
                                      XmNtopOffset, 20, 
                                      XmNbottomAttachment, XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_WIDGET,
                                      XmNleftWidget,track_case_data,
                                      XmNrightOffset ,20,
                                      XmNrightAttachment, XmATTACH_NONE,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);  

    sep = XtVaCreateManagedWidget("sep", xmSeparatorGadgetClass,form,
                                      XmNorientation, XmHORIZONTAL,
                                      XmNtopAttachment,XmATTACH_WIDGET,
                                      XmNtopWidget,track_case_data,
                                      XmNtopOffset, 10,
                                      XmNbottomAttachment,XmATTACH_NONE,
                                      XmNleftAttachment, XmATTACH_FORM,
                                      XmNrightAttachment,XmATTACH_FORM,
                                      XmNbackground, colors[0xff],
                                      NULL);    

    button_ok = XtVaCreateManagedWidget(langcode("WPUPTSP005"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, sep, 
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 0,
                                      XmNleftOffset, 5,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 1,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

   button_clear = XtVaCreateManagedWidget(langcode("WPUPTSP006"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, sep, 
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5, 
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 1,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 2,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);

    button_cancel = XtVaCreateManagedWidget(langcode("UNIOP00002"),xmPushButtonGadgetClass, form,
                                      XmNtopAttachment, XmATTACH_WIDGET,
                                      XmNtopWidget, sep, 
                                      XmNtopOffset, 5,
                                      XmNbottomAttachment, XmATTACH_FORM,
                                      XmNbottomOffset, 5,
                                      XmNleftAttachment, XmATTACH_POSITION,
                                      XmNleftPosition, 2,
                                      XmNrightAttachment, XmATTACH_POSITION,
                                      XmNrightPosition, 3,
                                      XmNrightOffset, 5,
                                      XmNbackground, colors[0xff],
                                      XmNnavigationType, XmTAB_GROUP,
                                      XmNtraversalOn, True,
                                      NULL);


   XtAddCallback(button_ok, XmNactivateCallback, Track_station_now, track_station_dialog);
   XtAddCallback(button_cancel, XmNactivateCallback, track_station_destroy_shell, track_station_dialog);
   XtAddCallback(button_clear, XmNactivateCallback, Track_station_clear, track_station_dialog);

   XmToggleButtonSetState(track_case_data,False,False);
   XmToggleButtonSetState(track_match_data,True,False);

   pos_dialog(track_station_dialog);

   delw = XmInternAtom(XtDisplay(track_station_dialog),"WM_DELETE_WINDOW", False);
   XmAddWMProtocolCallback(track_station_dialog, delw, track_station_destroy_shell, (XtPointer)track_station_dialog);

   if (track_station_on==1){
       XmTextFieldSetString(track_station_data,tracking_station_call);
   }

   XtManageChild(form);  
   XtManageChild(pane);  
   
   XtPopup(track_station_dialog,XtGrabNone);
   fix_dialog_size(track_station_dialog);
   } else {
     XRaiseWindow(XtDisplay(track_station_dialog), XtWindow(track_station_dialog));    
   }
}

