/* All of the misc entry points to be included for all packages */

#ifndef __XASTIR_H_
#define __XASTIR_H_

#include <Xm/Xm.h>
#include "db.h"
#include "messages.h"
#include "fcc_data.h"
#include "rac_data.h"

extern int debug_level;

extern long convert_lat_string(char *lat);
extern long convert_long_string(char *lng);

extern char *convert_long_lat_string(long lat, char *str);
extern char *convert_long_lat_string_hp(long lat, char *str);
extern char *convert_long_long_string(long lon, char *str);
extern char *convert_long_long_string_hp(long lon, char *str);

extern int wait_to_redraw;
/*extern char my_callsign[MAX_CALLSIGN+1];*/

extern void pad_callsign(char *callsignout, char *callsignin);

extern int  mem_find_data(DataRow fill);
extern void mem_get_data(DataRow *fill, int record_num);

extern char *to_upper(char *data);

extern void Send_message(Widget w, XtPointer clientData, XtPointer callData);

extern void create_gc(Widget w);

extern void Station_info(Widget w, XtPointer clientData, XtPointer calldata);

extern void Window_Quit(Widget w, XtPointer client, XtPointer call);

extern void fix_dialog_size(Widget w);
extern void fix_dialog_vsize(Widget w);

extern int debug_level;
extern GC gc;
extern int colors[];
extern long mid_x_long_offset;
extern long mid_y_lat_offset;
extern long x_long_offset;
extern long y_lat_offset;
extern long size;
extern long screen_width;
extern long screen_height;
extern int long_lat_grid;
extern Pixmap  pixmap;
extern Pixmap  pixmap_final;
extern int map_color_levels;
extern int map_auto_maps;
extern Widget da;
extern Widget text;
extern XtAppContext app_context;
extern Widget hidden_shell;

extern void sort_list(char *filename,int size, Widget list, int *item);

/* from db.c */
extern void display_file(Widget w);
extern void clean_data_file(void);
extern void mclean_data_file(void);
extern void read_file_line(FILE *f);
extern void my_station_add(char *my_call_sign, char my_group, char my_symbol, char *my_long, char *my_lat, char *my_phg, char *my_comment);
extern void station_del(char *callsign);
extern void mdisplay_file(char msg_type);
extern int locate_station(Widget w, char *call, int follow_case, int get_match);
extern char *to_upper(char *data);
extern int  is_xnum_or_dash(char *data, int max);
extern int new_message_data;
extern int stations;
extern void update_messages(void);
extern void mdelete_messages_from(char *from);
extern void mdelete_messages_to(char *to);
extern void mem_display(void);
extern long sort_input_database(char *filename, char *fill, int size);
extern void sort_display_file(char *filename, int size);
extern void clear_sort_file(char *filename);
extern int packet_data_display;
extern void display_packet_data(void);
extern int redraw_on_new_packet_data;
extern void serial_decode(char *line, char from, int port);
void my_station_gps_change(char *pos_long, char *pos_lat, char *course, char *speed, char speedu, char *alt, char altu, char *sats);
extern char *remove_trailing_spaces(char *data);
extern char *remove_trailing_asterisk(char *data);

/* from draw_symbols.c */
void clear_symbol_data(void);
void load_pixmap_symbol_file(char *filename);

/* from messages.c */
extern int message_counter;
extern int auto_reply;
extern char auto_reply_message[100];
extern void clear_outgoing_messages(void);
extern void reset_outgoing_messages(void);
extern void output_message(char *from, char *to, char *message);
extern void check_and_transmit_messages(time_t time);
extern Message_Window mw[MAX_MESSAGE_WINDOWS+1];
extern void clear_message_windows(void);

/* from sound.c */
extern pid_t play_sound(char *sound_cmd, char *soundfile);
extern int sound_done(void);

/* from fcc_data.c */
extern int fcc_data_available;
extern int search_fcc_data_appl(char *callsign, FccAppl *data);
extern void check_fcc_data(void);

/* from rac_data.c */
extern int rac_data_available;
extern int search_rac_data_appl(char *callsign, rac_record *data);
extern void check_rac_data(void); 

/* from lang.c */
extern int load_language_file(char *filename);
extern char *langcode(char *code);
extern char langcode_hotkey(char *code);

/* from sound.c */
extern pid_t play_sound(char *sound_cmd, char *soundfile);      

/* from util.c */
extern int position_amb_chars;
extern char *output_lat(char *in_lat);
extern char *output_long(char *in_long);
extern char *get_line(FILE *f, char *linedata, int maxline);
extern time_t time_from_aprsstring(char *timestamp);
extern char *compress_posit(const char *lat, const char group, const char *lon, const char symbol,
			    const int course, const int speed, const char *phg);
void uncompress_posit(const char *input, char *lat, char *ns, char *lon, char *ew, APRS_Symbol *symbol,
		      char *course, char *speed, char *speed_unit, char *phg, char *altitude, char *alt_unit);

/* from location.c */
extern void set_last_position(void);
extern void map_pos_last_position(void);

/* from location_gui.c */
extern void Last_location(Widget w, XtPointer clientData, XtPointer callData);
extern void Jump_location(Widget w, XtPointer clientData, XtPointer callData);
extern void map_pos(long mid_y, long mid_x, long sz);

#define MAX_LINE_SIZE 300

#endif /* __XASTIR_H_ */
